/*
 * PROGRAM: fpath.c
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#ifdef __cplusplus
#include <osfcn.h>
#endif

#include "pstr.h"

void ckprint(const char *name)
{
	if (access(name, 0) != -1)
		(void) printf("%s\n", name);
}

int main(int argc, char *argv[])
{
	int i;
	static const char SEP[] = ":";
	const char *path = (char *)0;

	for (i = 1; i < argc; ++i) {
		pstr_assign(&path, getenv("PATH"));
		if (strchr(argv[i], '/') || path[0] == '\0')
			ckprint(argv[i]);
		else {
			/*CASTAWAYCONST*/
			const char *cp = strtok((char *)path, SEP);
			while (cp != (char *)0) {
				if (*cp == '\0')
					ckprint(argv[i]);
				else
					ckprint(Tstr_3(cp, "/", argv[i]));
				cp = strtok((char *)0, SEP);
			}
		}
	}
	pstr_delete(path);

	return 0;
}
