/*
 * PROGRAM: fpath2.c
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#ifdef __cplusplus
#include <osfcn.h>
#endif

void ckprint(const char *name)
{
	if (access(name, 0) != -1)
		(void) printf("%s\n", name);
}

int main(int argc, char *argv[])
{
	int i;
	static const char SEP[] = ":";
	char *path = getenv("PATH");

	for (i = 1; i < argc; ++i) {
		if (strchr(argv[i], '/') || path == (char *)0)
			ckprint(argv[i]);
		else {
			const char *cp;
			char *sp = malloc(strlen(path) + 1);
			if (sp == (char *)0)
				abort();
			strcpy(sp, path);
			cp = strtok(sp, SEP);
			while (cp != (char *)0) {
				if (*cp == '\0')
					ckprint(argv[i]);
				else {
					char *fn = malloc(strlen(cp) + 1
							+ strlen(argv[i]) + 1);
					if (fn == (char *)0)
						abort();
					strcpy(fn, cp);
					strcat(fn, "/");
					strcat(fn, argv[i]);
					ckprint(fn);
					free(fn);
				}
				cp = strtok((char *)0, SEP);
			}
			free(sp);
		}
	}

	return 0;
}
