/*
 * MODULE: getline.c
*/

#include <stdio.h>
#include <string.h>
#include "pstr.h"

size_t getline(FILE *fp, const char **strp)
{
	char buff[80];
	size_t len = 0;
	pstr_assign(strp, (char *)0);
	while (fgets(buff, sizeof buff, fp)) {
		int blen = strlen(buff);
		if (blen > 1
		 && buff[blen - 2] == '\\'
		 && buff[blen - 1] == '\n')
			buff[blen -= 2] = '\0';
		if (blen > 0) {
			pstr_assign(strp, Tstr_2(*strp, buff));
			len += blen;
			if (buff[blen - 1] == '\n')
				break;
		}
	}
	return len;
}

#ifdef TEST

int main()
{
	const char *lp = (char *)0;
	int n;

	while (n = getline(stdin, &lp))
		printf("(%d)\t%s", n, lp);

	return 0;
}

#endif
